using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
	class ColliderDebug : MonoBehaviour
    {
        void Update()
        {
            foreach (Collider2D coller in gameObject.GetComponents<Collider2D>())
            {
                ModAPI.Draw.Collider(coller); //Instance.AddComponent<ColliderDebug>(); (add this to instances)
            }
        }
    }
    public class Mod
    {
        public static void Main()
        {				
		  CategoryBuilder.Create("AK AND RD MOD", "Avtomat Kalashnikova and Rifle Dynamics mod", ModAPI.LoadSprite("categoryicon.png"));
            //READ README.TXT
            ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M with tac block, scope, grip",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mi1.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1z.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M without anything",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mi2.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1z.png", 12f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m2.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M with grip",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mi3.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1z.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m3.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M with grip and scope",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mi4.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1z.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m4.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M with grip and scope and zoomer for scope (up)",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mi5.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1z.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m5.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M with grip and scope and zoomer for scope (down)",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mi1.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1z.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m6.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M with grip and scope and tac block and zoomer for scope (down)",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mi8.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m1z.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74m8.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-545 SAG Civilian version",
                 DescriptionOverride = "Very tacticool gun",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak545i.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/akrdz2.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak545.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = false;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "AK-74M Tan Colour",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/ak74mti.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/akrdz1.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/ak74mt.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/ak74m1s.wav"),
                     };
                 }
             }
             ); ;
             ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("M1 Garand"),
                 NameOverride = "Rifle Dynamics 704 (RD-704)",
                 DescriptionOverride = "Very tacticool gun which used by all russian forces",
                 CategoryOverride = ModAPI.FindCategory("AK AND RD MOD"),
                 ThumbnailOverride = ModAPI.LoadSprite("icons/RDi.png", 30f),
                 AfterSpawn = (Instance) =>
                 {
ModAPI.KeepExtraObjects();
                        var ThompsonSlide = Instance.transform.Find("Slide");
                        ThompsonSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/akrdz3.png", 15f);
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("guns/rd704.png", 15f);
                     var firearm = Instance.GetComponent<FirearmBehaviour>();
                     Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm");
                     Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.700f, 0.1000f);  
                     firearm.casingPosition = new Vector3(-0.250f,0.100f);                     
                     customCartridge.name = "5.56x45mm";
                     customCartridge.Recoil *= 4f;
                     firearm.Cartridge = customCartridge;
                      Instance.GetComponent<FirearmBehaviour>().Automatic = true;
                       Instance.GetComponent<FirearmBehaviour>().AutomaticFireInterval = 0.1f;
                     Instance.FixColliders();
                     firearm.ShotSounds = new AudioClip[]
                     {
                        ModAPI.LoadSound("guns/asval.wav"),
                     };
                 }
             }
             ); ;
        }
    }
}